<template>
    <Form ref="form" v-slot="{ handleSubmit, values, meta }" :initialValues="initialValues">
         <div class="v-chart-account-form px-[40px] py-[30px]">

            <div class="pt-[5px] text-blue-700 w-80">
                <b>
                  <h2>Laon Agreement:</h2>
                </b>
              </div>

            <div class="grid gap-4 mb-4 md:grid-cols-4 mt-4">
                <div>
                    <Field name="startDate" v-slot="{ value, handleChange, errorMessage }" rules="required">
                        <label class="block mb-4 text-sm font-medium text-gray-900">Start Date<span class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-date-picker :model-value="value" @update:model-value="handleChange" class="mt-2"
                                    size="large" style="width: 100%" type="date" placeholder="Select Start Date"
                                    value-format="YYYY-MM-DD" format="DD/MM/YYYY" />
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                <div>
                    <Field name="companyId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">Reference No <span
                                class="sign">*</span>
                            <el-form-item :error="errorMessage">
                              <el-select :model-value="value" @update:model-value="handleChange" filterable
                              class="w-[100%] mt-2" placeholder="Select a Reference" size="large" clearable>
                              <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                          </el-select>
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                <div>
                    <Field name="idNo" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">ID No <span
                                class="sign">*</span>
                            <el-form-item :error="errorMessage">
                              <el-select :model-value="value" @update:model-value="handleChange" filterable
                              class="w-[100%] mt-2" placeholder="Select a Reference" size="large" clearable>
                              <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                          </el-select>
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                <div>
                    <Field name="idNo" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">ID No <span
                                class="sign">*</span>
                            <el-form-item :error="errorMessage">
                              <el-select :model-value="value" @update:model-value="handleChange" filterable
                              class="w-[100%] mt-2" placeholder="Select a Reference" size="large" clearable>
                              <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                          </el-select>
                            </el-form-item>
                        </label>
                    </Field>
                </div>
            </div>

            <div class="pt-[20px] text-blue-700 w-80">
                <b>
                  <h2>Register Collateral Infomation:</h2>
                </b>
              </div>
  
          <div class="grid gap-4 mb-4 md:grid-cols-4 mt-4">
                <div>
                    <Field name="fullName" type="text" v-slot="{ value, errorMessage, handleChange }" filterable rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                        Owner Name <span class="sign">*</span></label>
                        <el-form-item :error="errorMessage">
                            <el-input :model-value="value" @update:model-value="handleChange" placeholder="Owner Name" />
                        </el-form-item>
                    </Field>
                </div>
                <div>
                    <Field name="collateralNo" type="text" v-slot="{ value, errorMessage, handleChange }" filterable rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                           Collateral No <span class="sign">*</span></label>
                        <el-form-item :error="errorMessage">
                            <el-input :model-value="value" @update:model-value="handleChange" placeholder="Collateral No" />
                        </el-form-item>
                    </Field>
                </div>
                <div>
                  <Field name="startDate" v-slot="{ value, handleChange, errorMessage }" rules="required">
                    <label class="block mb-4 text-sm font-medium text-gray-900">Collateral Date<span class="sign">*</span>
                        <el-form-item :error="errorMessage">
                            <el-date-picker :model-value="value" @update:model-value="handleChange" class="mt-2"
                                size="large" style="width: 100%" type="date" placeholder="Select Collateral Date"
                                value-format="YYYY-MM-DD" format="DD/MM/YYYY" />
                        </el-form-item>
                    </label>
                </Field>
                </div>
                
                <div>
                  <Field name="telegramId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      Level of Confirmation Collateral<span class="sign"> *</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="province" />
                    </el-form-item>
                  </Field>
                </div>
             </div>
             <div class="pt-[20px] text-blue-700 w-80">
                <b>
                  <h2>Collateral Infomation:</h2>
                </b>
              </div>

             <div class="grid gap-4 mb-4 md:grid-cols-4 mt-4">
              <div>
                <Field name="compensation" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      សំណងខូចខាត<span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="province" />
                    </el-form-item>
                  </Field>
              </div>
              <div>
                <Field name="realEstateLocation" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                  <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                    ទីតាំងអចលនវត្ថុ<span class="sign">*</span></label>
                  <el-form-item :error="errorMessage">
                    <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                  </el-form-item>
                </Field>
              </div>
              <div>
                <Field name="landNo" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      លេខក្បាលដី<span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                    </el-form-item>
                  </Field>
              </div>
              <div>
                <Field name="idCertificate" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      វិញ្ញាបនបត្រម្ចាស់អចលនវត្ថុ<span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                    </el-form-item>
                  </Field>
              </div>
           </div>

         
  
          
            <div class="flex justify-center">
                <el-button v-if="!isReadonly" @click="handleSubmit($event, onSubmit(values, meta))"
                    class="bg-blue-700 hover:bg-blue-600 rounded-full ml-2 px-3 py-4 w-[100px]" size="large"
                    color="#1d4ed8">
                    Save
                </el-button>
            </div>
        </div>
    </Form>
  </template>
  <script>
  import {  ref } from "vue";
  import { Form, Field } from "vee-validate";
  
  export default {
    name: 'v-receiving-collateral-form',
    components: {
        Field,
        Form,
    },
    props: {
        data: {
            type: Object,
            default: () => ({}),
        },
        isEdit: {
            type: Boolean,
            default: false,
        },
    },
  
    emits: ["submit"],
    setup(props, { emit }) {
        const form = ref();
        const initialValues = props?.data || {};
  
        const onSubmit = (values, meta) => {
            if (meta.valid) {
                emit("submit", values);
            }
        };
  
        return {
            initialValues,
            form,
            onSubmit
        }
    }
  }
  </script>